//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#include <mmsystem.h>

#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
Graphics::TBitmap *Bmp = new Graphics::TBitmap();
byte *img;
//byte *imgg;
//byte *imgb;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
   delete Bmp;
   exit(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  int i, j;
//  byte* imgbufr;
//  byte* imgbufg;
//  byte* imgbufb;

  OpenPictureDialog1->Filter = GraphicFilter(__classid(Graphics::TBitmap));
  if (OpenPictureDialog1->Execute())
  {
     Bmp->Dormant();           // Free up GDI resources
     Bmp->FreeImage();         // Free up Memory
     Bmp->ReleaseHandle();
     Bmp->LoadFromFile(OpenPictureDialog1->FileName);

     Image1->Width  = Bmp->Width;
     Image1->Height = Bmp->Height;
     Image2->Width  = Bmp->Width;
     Image2->Height = Bmp->Height;
     Image1->Picture->Bitmap = Bmp;
     Image2->Left   = Image1->Left + Image1->Width + 10;
     Image2->Picture->Bitmap = Bmp;
     Label2->Caption = IntToStr(Bmp->Width)+" x "+IntToStr(Bmp->Height);
     Edit1->Text = IntToStr(Bmp->Width);
     Edit2->Text = IntToStr(Bmp->Height);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  if (Image2->Picture->Bitmap->Empty==true)
  {
     ShowMessage("no Image to Process");
     return;
  }

  Graphics::TBitmap *NBmp = new Graphics::TBitmap();

  int            w,h,newW,newH;
  double         dX,dY,x,y;
  int            i,j;
  int            ix,iy;                    // integer value of (x,y)
  double         fx,fy;                    // float value of (x,y)
  unsigned char  clr,
                 clrR,clrG,clrB,
                 nclr1,nclr2,nclr3,nclr4;  // color of neighbor 4 pixel

  w = Image1->Width;
  h = Image1->Height;
  newW = StrToInt(Edit1->Text);
  newH = StrToInt(Edit2->Text);
  if((newW <=0) ||(newH <=0))
  {
    ShowMessage("Invalided parameter");
    return;
  }
  NBmp->PixelFormat = pf24bit;
  NBmp->Width  = newW;
  NBmp->Height = newH;

  /* Caculate the step size of movement */
  dX = (double)w/(double)newW;
  dY = (double)h/(double)newH;

  for(j = 0 ; j < newH ; j++)
     for(i =0 ; i < newW ; i++)
     {
       x = dX*(double)i;
       y = dY*(double)j;

       ix = (int)x;         iy = (int)y;
       fx = x - (double)ix;  fy = y - (double)iy;

       nclr1 = GetRValue(Bmp->Canvas->Pixels[ix][iy]);
       nclr2 = GetRValue(Bmp->Canvas->Pixels[ix+1][iy]);
       nclr3 = GetRValue(Bmp->Canvas->Pixels[ix][iy+1]);
       nclr4 = GetRValue(Bmp->Canvas->Pixels[ix+1][iy+1]);
       // Bilinear
       clrR=(byte)((1.0-fx)*(1.0-fy)*(double)nclr1+(fx)*(1.0-fy)*(double)nclr2
                  +(1.0-fx)*    (fy)*(double)nclr3+(fx)*    (fy)*(double)nclr4);

       nclr1 = GetGValue(Bmp->Canvas->Pixels[ix][iy]);
       nclr2 = GetGValue(Bmp->Canvas->Pixels[ix+1][iy]);
       nclr3 = GetGValue(Bmp->Canvas->Pixels[ix][iy+1]);
       nclr4 = GetGValue(Bmp->Canvas->Pixels[ix+1][iy+1]);
       // Bilinear
       clrG=(byte)((1.0-fx)*(1.0-fy)*(double)nclr1+(fx)*(1.0-fy)*(double)nclr2
                  +(1.0-fx)*    (fy)*(double)nclr3+(fx)*    (fy)*(double)nclr4);

       nclr1 = GetBValue(Bmp->Canvas->Pixels[ix][iy]);
       nclr2 = GetBValue(Bmp->Canvas->Pixels[ix+1][iy]);
       nclr3 = GetBValue(Bmp->Canvas->Pixels[ix][iy+1]);
       nclr4 = GetBValue(Bmp->Canvas->Pixels[ix+1][iy+1]);
       // Bilinear
       clrB=(byte)((1.0-fx)*(1.0-fy)*(double)nclr1+(fx)*(1.0-fy)*(double)nclr2
                  +(1.0-fx)*    (fy)*(double)nclr3+(fx)*    (fy)*(double)nclr4);

       NBmp->Canvas->Pixels[i][j] = (TColor)RGB(clrR,clrG,clrB);
     }
  Image2->Width = newW;
  Image2->Height = newH;
  Image2->Picture->Bitmap = NBmp;
  delete NBmp;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
 if (Image2->Picture->Bitmap->Empty==true)
     ShowMessage("no Image to Save");
 else
 {
  //SavePictureDialog1->Filter = GraphicFilter(__classid(Graphics::TBitmap));
  if (SavePictureDialog1->Execute())
  {
     Image2->Picture->SaveToFile(SavePictureDialog1->FileName);
  }
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  Bmp->Dormant();
  Bmp->FreeImage();
  Bmp->ReleaseHandle();
  Image1->Picture->Bitmap = Bmp;
  Image2->Picture->Bitmap = Bmp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
  if (Image2->Picture->Bitmap->Empty==true)
  {
     ShowMessage("no Image to Process");
     return;
  }

  Graphics::TBitmap *NBmp = new Graphics::TBitmap();

  int            w,h,newW,newH;
  double         dX,dY,x,y;
  double         scalar;                   // Zoom scalar
  int            i,j;
  int            ix,iy;                    // integer value of (x,y)
  double         fx,fy;                    // float value of (x,y)
  unsigned char  clr,
                 clrR,clrG,clrB,
                 nclr1,nclr2,nclr3,nclr4;  // color of neighbor 4 pixel

  w = Image1->Width;
  h = Image1->Height;
  scalar = StrToFloat(Edit3->Text);

  newW  =  (int)((double)w*scalar);
  newH  =  (int)((double)h*scalar);

  if((newW <=0) ||(newH <=0))
  {
    ShowMessage("Invalided parameter");
    return;
  }
  NBmp->PixelFormat = pf24bit;
  NBmp->Width  = newW;
  NBmp->Height = newH;

  /* Caculate the step size of movement */
  dX = (double)w/(double)newW;
  dY = (double)h/(double)newH;

  for(j = 0 ; j < newH ; j++)
     for(i =0 ; i < newW ; i++)
     {
       x = dX*(double)i;
       y = dY*(double)j;

       ix = (int)x;         iy = (int)y;
       fx = x - (double)ix;  fy = y - (double)iy;

       nclr1 = GetRValue(Bmp->Canvas->Pixels[ix][iy]);
       nclr2 = GetRValue(Bmp->Canvas->Pixels[ix+1][iy]);
       nclr3 = GetRValue(Bmp->Canvas->Pixels[ix][iy+1]);
       nclr4 = GetRValue(Bmp->Canvas->Pixels[ix+1][iy+1]);
       // Bilinear
       clrR=(byte)((1.0-fx)*(1.0-fy)*(double)nclr1+(fx)*(1.0-fy)*(double)nclr2
                  +(1.0-fx)*    (fy)*(double)nclr3+(fx)*    (fy)*(double)nclr4);

       nclr1 = GetGValue(Bmp->Canvas->Pixels[ix][iy]);
       nclr2 = GetGValue(Bmp->Canvas->Pixels[ix+1][iy]);
       nclr3 = GetGValue(Bmp->Canvas->Pixels[ix][iy+1]);
       nclr4 = GetGValue(Bmp->Canvas->Pixels[ix+1][iy+1]);
       // Bilinear
       clrG=(byte)((1.0-fx)*(1.0-fy)*(double)nclr1+(fx)*(1.0-fy)*(double)nclr2
                  +(1.0-fx)*    (fy)*(double)nclr3+(fx)*    (fy)*(double)nclr4);

       nclr1 = GetBValue(Bmp->Canvas->Pixels[ix][iy]);
       nclr2 = GetBValue(Bmp->Canvas->Pixels[ix+1][iy]);
       nclr3 = GetBValue(Bmp->Canvas->Pixels[ix][iy+1]);
       nclr4 = GetBValue(Bmp->Canvas->Pixels[ix+1][iy+1]);
       // Bilinear
       clrB=(byte)((1.0-fx)*(1.0-fy)*(double)nclr1+(fx)*(1.0-fy)*(double)nclr2
                  +(1.0-fx)*    (fy)*(double)nclr3+(fx)*    (fy)*(double)nclr4);

       NBmp->Canvas->Pixels[i][j] = (TColor)RGB(clrR,clrG,clrB);
     }
  Image2->Width = newW;
  Image2->Height = newH;
  Image2->Picture->Bitmap = NBmp;
  delete NBmp;
}
//---------------------------------------------------------------------------




void __fastcall TForm1::SaveasBinary1Click(TObject *Sender)
{
  Graphics::TBitmap* bibmp=new Graphics::TBitmap;

  bibmp->PixelFormat = pf1bit;

  if (Image2->Picture->Bitmap->Empty==true)
     ShowMessage("no Image to Save");
  else
  {
     byte  R,G,B;
     // set bitmap to binary image
     bibmp->Width = Bmp->Width;
     bibmp->Height= Bmp->Height;
  for(int j=0; j<Bmp->Height ; j++)
  {
    for(int i=0; i < Bmp->Width ; i++)
    {
     R = GetRValue(Bmp->Canvas->Pixels[i][j]);
     G = GetGValue(Bmp->Canvas->Pixels[i][j]);
     B = GetBValue(Bmp->Canvas->Pixels[i][j]);

     if(R+G+B>384)
     {
        bibmp->Canvas->Pixels[i][j] = clWhite;
     }
     else
     {
        bibmp->Canvas->Pixels[i][j] = clRed;
     }
    }
  }
     Image2->Picture->Bitmap = bibmp;
     SavePictureDialog1->Filter = GraphicFilter(__classid(Graphics::TBitmap));
     if (SavePictureDialog1->Execute())
     {
         bibmp->SaveToFile(SavePictureDialog1->FileName);
     }
  }

  delete bibmp;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image2MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
 Label5->Caption = IntToStr(X) + " x " + IntToStr(Y);
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button10Click(TObject *Sender)
{
    Graphics::TBitmap* inversbmp=new Graphics::TBitmap;
    byte              *ptr1,*ptr2;

    inversbmp->PixelFormat = pf24bit;
    inversbmp->Width       = Bmp->Width;
    inversbmp->Height      = Bmp->Height;
#if 1
    for(int y=0;y<Bmp->Height;y++)
    {
       ptr1=(byte *)(inversbmp->ScanLine[y]);
       ptr2=(byte *)(Bmp->ScanLine[y]);
       for(int x=0;x<Bmp->Width;x++)
       {

          ptr1[3*x]   = 255 - ptr2[3*x];
          ptr1[3*x+1] = 255 - ptr2[3*x+1];
          ptr1[3*x+2] = 255 - ptr2[3*x+2];
       }
    }
#else
    for(int y=0;y<Bmp->Height;y++)
    {
       ptr1=(byte *)(inversbmp->ScanLine[y]);
       ptr2=(byte *)(Bmp->ScanLine[y]);
       for(int x=0;x<(Bmp->Width*3);x+=3)
       {
          ptr1[x]   = 255 - ptr2[x];
          ptr1[x+1] = 255 - ptr2[x+1];
          ptr1[x+2] = 255 - ptr2[x+2];
       }
    }
#endif

    Image2->Picture->Assign(inversbmp);

    delete  inversbmp;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button12Click(TObject *Sender)
{
    Graphics::TBitmap *Bmp1 = new Graphics::TBitmap();
    Byte *ptr;
    int r,g,b;
    int gray;
    int i,j;
    int threshold = 128;

    //threshold=ScrlBarThreshold->Position; //ouOScrlBar֭ȦӤw
    //edtThreshold->Text=ScrlBarThreshold->Position;
    Bmp1->Assign(Bmp);

    for( j=0 ; j< Bmp1->Height ; j++) //_ ڪ"["ܤXXD
    {
        ptr = (Byte *)Bmp1->ScanLine[j];
        for( i=0 ; i < Bmp1->Width ; i++ )
        {
            b=ptr[i*3];
            g=ptr[i*3+1];
            r=ptr[i*3+2];

            gray = 0.299*r + 0.587*g + 0.114*b;

            if(gray>threshold)
                gray=255;
            else
                gray=0;

            ptr[i*3]=(Byte)gray;
            ptr[i*3+1]=(Byte)gray;
            ptr[i*3+2]=(Byte)gray;
        }
    }

    Image2->Picture->Assign(Bmp1);
    delete Bmp1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button13Click(TObject *Sender)
{
    Graphics::TBitmap *Bmp1 = new Graphics::TBitmap();
    Byte *ptr;
    int r,g,b;
    int gray;
    int i,j;

    //threshold=ScrlBarThreshold->Position; //ouOScrlBar֭ȦӤw
    //edtThreshold->Text=ScrlBarThreshold->Position;
    Bmp1->Assign(Bmp);

    for( j=0 ; j< Bmp1->Height ; j++) //_ ڪ"["ܤXXD
    {
        ptr = (Byte *)Bmp1->ScanLine[j];
        for( i=0 ; i < Bmp1->Width ; i++ )
        {
            b=ptr[i*3];
            g=ptr[i*3+1];
            r=ptr[i*3+2];

            gray = 0.299*r + 0.587*g + 0.114*b;

            ptr[i*3]=(Byte)gray;
            ptr[i*3+1]=(Byte)gray;
            ptr[i*3+2]=(Byte)gray;
        }
    }

    Image2->Picture->Assign(Bmp1);
    delete Bmp1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button14Click(TObject *Sender)
{
    Graphics::TBitmap *YBmp  = new Graphics::TBitmap();
    Graphics::TBitmap *CbBmp = new Graphics::TBitmap();
    Graphics::TBitmap *CrBmp = new Graphics::TBitmap();
    Graphics::TBitmap *SBmp = new Graphics::TBitmap();
    Graphics::TBitmap *DBmp = new Graphics::TBitmap();
    int Y,Cr,Cb,R,G,B;

    byte*  ptr,*Yptr,*Cbptr,*Crptr;
    YBmp->Width     = Bmp->Width;
    YBmp->Height    = Bmp->Height;
    YBmp->PixelFormat = pf24bit;

    CbBmp->Width    = Bmp->Width;
    CbBmp->Height   = Bmp->Height;
    CbBmp->PixelFormat = pf24bit;

    CrBmp->Width    = Bmp->Width;
    CrBmp->Height   = Bmp->Height;
    CrBmp->PixelFormat = pf24bit;

    SBmp->Width     = (int)(Bmp->Width / 2);
    SBmp->Height    = (int)(Bmp->Height / 2);
    SBmp->PixelFormat = pf24bit;

    DBmp->Width     = (int)Bmp->Width;
    DBmp->Height    = Bmp->Height + (int)(Bmp->Height/ 2);
    DBmp->PixelFormat = pf24bit;

    for(int j=0; j<Bmp->Height; j++)
    {
        ptr   = (Byte *)Bmp->ScanLine[j];
        Yptr  = (Byte *)YBmp->ScanLine[j];
        Cbptr = (Byte *)CbBmp->ScanLine[j];
        Crptr = (Byte *)CrBmp->ScanLine[j];

        int index=0;
        for( int i=0;  i<Bmp->Width ; i++ )
        {
            B = ptr[index];
            G = ptr[index+1];
            R = ptr[index+2];

            Y  = 0.299*R+0.587*G+0.114*B;
            Cr = 0.5*R-0.419*G-0.081*B+128;
            Cb = -0.169*R-0.332*G+0.5*B+128;

            Yptr[index]  = Y;
            Yptr[index+1]= Y;
            Yptr[index+2]= Y;
            Cbptr[index]  = Cb;
            Cbptr[index+1]= Cb;
            Cbptr[index+2]= Cb;
            Crptr[index]  = Cr;
            Crptr[index+1]= Cr;
            Crptr[index+2]= Cr;

            index+=3;
        }
    }

    DBmp->Canvas->Draw(0,0,YBmp);
    SetStretchBltMode(SBmp->Canvas->Handle, STRETCH_HALFTONE);
    SBmp->Canvas->CopyMode=cmSrcCopy;

    SBmp->Canvas->CopyRect(Rect(0, 0, SBmp->Width, SBmp->Height),
      CbBmp->Canvas, Rect(0, 0, CbBmp->Width, CbBmp->Height));
    DBmp->Canvas->Draw(0,Image2->Height,SBmp);

    SBmp->Canvas->CopyRect(Rect(0, 0, SBmp->Width, SBmp->Height),
    CrBmp->Canvas, Rect(0, 0, CrBmp->Width, CrBmp->Height));
    DBmp->Canvas->Draw((int)(Image2->Width/2),Image2->Height,SBmp);

    Image2->Width = DBmp->Width;
    Image2->Height= DBmp->Height;
    Image2->Picture->Assign(DBmp);

    delete  YBmp;
    delete  CrBmp;
    delete  CbBmp;
    delete  SBmp,DBmp;
}
//---------------------------------------------------------------------------

